{% extends "base.html" %}
{% block title %}Terminal{% endblock %}
{% block content %}
  <div class="outer-div">
    <div class="mx-auto">
      <h1 id="app-heading"></h1>
      <p>Status: <strong>{{ status }}</strong></p>

      {% if status == 200 %}
            <!-- Container navbar -->
        <ul class="nav nav-tabs" id="myTab" role="tablist">
          {% for container in application.container_set.all %}
            <li class="nav-item" role="presentation">
              <button class="nav-link {% if forloop.first %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#container-{{ container.id }}-terminal-tab-pane" type="button" role="tab" aria-controls="container-{{ container.id }}-terminal-tab-pane" aria-selected="true">{{ container }}</button>
            </li>
          {% endfor %}
        </ul>

            <!-- Container terminal tab -->
        <div class="tab-content app-display" id="myTabContent">
          {% for container in application.container_set.all %}
            <div class="tab-pane fade {% if forloop.first %}show active{% endif %}" id="container-{{ container.id }}-terminal-tab-pane" role="tabpanel" aria-labelledby="container-{{ container.id }}-terminal-tab-pane" tabindex="0">
              <div class="bg-dark text-white p-5">
                        <pre id="terminal-{{ container.id }}" class="text-wrap">{{ log }}</pre>
                <form class="w-full" data-container-id="{{ container.id }}">
                  {% csrf_token %}
                  <input id="command-input-{{ container.id }}" name="command" class="form-control">
                </form>
              </div>
            </div>
          {% endfor %}
        </div>
      {% else %}
        <h5>{{ log }}</h5>
      {% endif %}
    </div>
  </div>
  {% if status == 200 %}
    <script>
        // Get app id from the current URL
      const appId = window.location.href.split('/').at(-2);
      $('#app-heading').text(`Terminal for ${appId}`);
      $('form').submit(function(e) {
        e.preventDefault();
        const containerId = $(this).data('container-id');
        const command = $(`#command-input-${containerId}`).val();
        $(`#command-input-${containerId}`).attr("disabled", true);
        $(`#terminal-${containerId}`).html(`${$(`#terminal-${containerId}`).html()}<br/>$ ${command}`);
        $(`#command-input-${containerId}`).val('');
        $.ajax({
          type: 'GET',
          url: `/terminal/${appId}/`,
          data: {
            command: command,
            container_id: containerId,
            "X-Requested-With": "XMLHttpRequest"
          },
          success: function(response) {
            console.log(response);
            const output = response.output.replace(/\n/g, '<br/>');
            console.log(output);
            $(`#terminal-${containerId}`).html(`${$(`#terminal-${containerId}`).html()}<br/>${output}<br/>`);
            $(`#command-input-${containerId}`).attr("disabled", false);
            $(`#command-input-${containerId}`).focus();
          },
          error: function(response) {
            console.log(response.errorMessage);
            $(`#terminal-${containerId}`).html(`${$(`#terminal-${containerId}`).html()}<br/>Failed to execute command "${command}". Please contact STRAPPER dev team for support.<br/>`);
            $(`#command-input-${containerId}`).attr("disabled", false);
            $(`#command-input-${containerId}`).focus();
          }
        })
      })
    </script>
  {% endif %}
{% endblock %}